#!/usr/local/bin/perl
#
# reads a tournament file
# assigns numbers to teams
# translates into data file for bugs
# prints to file.bug
#
# data looks like this
# list(T=12,G=24,htm=c(1,2,4,2,3,4,2,2,3,3,2),atm=c(1,2,3,4,5,6,7),
# hsc=c(0,1,2,3,2,2,2,2,2,1,1,1),asc=c(1,2,0,0,0,0,0,0,0,0,0))
# inits -- none needed? 

# for soccer, set this to 9
# for ultimate, change to smax=25
$smax = 10 ; # scores above this are not expected and will be flagged
$large_s = 0 ; # whether the value of smax has gone up and needs reporting
$verbose = 1 ; 
$winbydef = 12 ; 
$losebydef = 3 ; 
$includedef = 0 ; 
$type = 4 ; 

eval "\$$1=\$2" while $ARGV[0]=~ /^(\w+)=(.*)/ && shift;

$file = $ARGV[0] ;
$filebug = $ARGV[0].".bug" ;
$filetms = $ARGV[0].".tms" ;
$filedat = $ARGV[0].".dat" ;

open ( DAT , "> $filedat" ) ;
open ( TMS , "> $filetms" ) ;

$g = 0 ; $T = 0 ; 
while ( <> ) {			# 
    if ( !/^\#|^%|^\/\*/ ) {
	s/^\s*// ; # kill white space
	if ( /\*/ || ( (!$includedef) && /\!/ ) ) { # score-less line - no action 
	} else {
	    if ( /\!/ ) { # win by default 
		$g ++ ; 
		($t1 , $s1 , $t2 , @resta ) = split ; 
		if ( !($s1 eq "!") ) {
		    print "EEK " . $_ ; 
		}
		$s1 = $winbydef ; 
		$s2 = $losebydef ; 
	    } else {
		# hopefully this is a score 
		$g ++ ;
		($t1 , $s1 , $t2 , $s2 , @resta) = split ;
#		print "t1 = $t1 , s1 = $s1 , t2 = $t2 , s2 = $s2 \n" ; 
	    }
	    $rest = join ( " " , @resta ) ; 
	    if ( length($rest) > 0 ) {
		print "line $g : $rest\n" ;
	    }

	    # check s1 and s2 are numeric

	    # capitalize team names

	    # check each team against lists
	    $t1new = 1 ; 
	    for ( $t = 1 ; $t <= $T ; $t ++ ) {
		if ( ($t1 eq $teams[$t]) ) { $t1 = $t ; $t1new = 0; break ; }
	    }
	    if ( $t1new ) { $T ++ ; $teams[$T] = $t1 ; $t1 = $T ; }
	    
	    $t2new = 1 ; 
	    for ( $t = 1 ; $t <= $T ; $t ++ ) {
		if ( ($t2 eq $teams[$t] )) { $t2 = $t ; $t2new = 0; break ; }
	    }
	    if ( $t2new ) { $T ++ ; $teams[$T] = $t2 ; $t2 = $T ; }
	    if ( $s1 > $smax ) { $smax = $s1 ; print STDERR " unexpected large score $s1\n" ; $large_s = 1 ; }
	    if ( $s2 > $smax ) { $smax = $s2 ; print STDERR " unexpected large score $s2\n" ; $large_s = 1 ; }
	    
	    $htmlist .= " $t1 " ; 
	    $atmlist .= " $t2 " ; 
	    $hsclist .= " $s1 " ; 
	    $asclist .= " $s2 " ; 
	    if( !($g % 20 ) ) {
		$htmlist .= " \n" ; 
		$atmlist .= " \n" ; 
		$hsclist .= " \n" ; 
		$asclist .= " \n" ; 
	    }
	}			# 
    }
}
    print "total number of teams $T\n" ;
    print "total number of games $g\n" ;
for ( $t = 1 ; $t <= $T ; $t ++ ) {
    print "team $t : $teams[$t] \n";
    print TMS "$t $teams[$t] \n";
}
$htmlist =~ s/\ \ /,/g ;
$atmlist =~ s/\ \ /,/g ;
$hsclist =~ s/\ \ /,/g ;
$asclist =~ s/\ \ /,/g ;

print DAT "list(T=$T,G=$g,\n" ; # this needs to go in the head of the bug file
print DAT "htm=c($htmlist),\n" ;
print DAT "atm=c($atmlist),\n" ;
print DAT "hsc=c($hsclist),\n" ;
print DAT "asc=c($asclist)\n)\n" ;
close (DAT);




