#!/usr/local/bin/perl
#
# reads a tournament file
# assigns numbers to teams
# translates into numeric form for infera.c
# prints to file.inf
#

# for soccer, set this to 9
# for ultimate, change to smax=25
$smax = 10 ; # scores above this are not expected and will be flagged
$large_s = 0 ; # whether the value of smax has gone up and needs reporting
				# to infera (which may be assuming some default
$verbose = 1 ; 
$winbydef = 12 ; 
$losebydef = 3 ; 
$includedef = 0 ; 
$type = 4 ; 
$odds = 1 ; 
$extra="" ; # extra arguments for the inference machine
$extras="" ; # extra arguments for the inference machine
eval "\$$1=\$2" while $ARGV[0]=~ /^(\w+)=(.*)/ && shift;

if ( $type == 2 ) { # infer o and d potentials
    $arglist = " -type 2 " ;
    $sort_on_me = 4 ; 
}             
elsif ( $type ==  4 ) { # infer o and d potentials
    $arglist = " -type 4 " ;
    $sort_on_me = 6 ; 
}             
else 
{                    # just 'a' potentials
    $arglist = "" ;
    $sort_on_me = 2 ; 
    $odds = 0 ; # no odds support
}
$file = $ARGV[0] ;
$fileinf = $ARGV[0].".inf" ;
$filetms = $ARGV[0].".tms" ;
$fileout = $ARGV[0].".out" ;
$fileran = $ARGV[0].".ran" ;
$fileodd = $ARGV[0].".odd" ;
$fileodl = $ARGV[0].".odl" ;
if ( $odds ) { $arglist = " -oddsfile $fileodd  -odlfile $fileodl ".$arglist ; }

open ( INF , "> $fileinf" ) ;
open ( TMS , "> $filetms" ) ;

$g = 0 ; $T = 0 ; 
while ( <> ) {			# 
    if ( !/^\#|^%|^\/\*/ ) {
	s/^\s*// ; # kill white space
	if ( /\*/ || ( (!$includedef) && /\!/ ) ) { # score-less line - no action 
	} else {
	    if ( /\!/ ) { # win by default 
		$g ++ ; 
		($t1 , $s1 , $t2 , @resta ) = split ; 
		if ( !($s1 eq "!") ) {
		    print "EEK " . $_ ; 
		}
		$s1 = $winbydef ; 
		$s2 = $losebydef ; 
	    } else {
		# hopefully this is a score 
		$g ++ ;
		($t1 , $s1 , $t2 , $s2 , @resta) = split ;
#		print "t1 = $t1 , s1 = $s1 , t2 = $t2 , s2 = $s2 \n" ; 
	    }
	    $rest = join ( " " , @resta ) ; 
	    if ( length($rest) > 0 ) {
		print "line $g : $rest\n" ;
	    }

	    # check s1 and s2 are numeric

	    # capitalize team names

	    # check each team against lists
	    $t1new = 1 ; 
	    for ( $t = 1 ; $t <= $T ; $t ++ ) {
		if ( ($t1 eq $teams[$t]) ) { $t1 = $t ; $t1new = 0; break ; }
	    }
	    if ( $t1new ) { $T ++ ; $teams[$T] = $t1 ; $t1 = $T ; }
	    
	    $t2new = 1 ; 
	    for ( $t = 1 ; $t <= $T ; $t ++ ) {
		if ( ($t2 eq $teams[$t] )) { $t2 = $t ; $t2new = 0; break ; }
	    }
	    if ( $t2new ) { $T ++ ; $teams[$T] = $t2 ; $t2 = $T ; }
	    if ( $s1 > $smax ) { $smax = $s1 ; print STDERR " unexpected large score $s1\n" ; $large_s = 1 ; }
	    if ( $s2 > $smax ) { $smax = $s2 ; print STDERR " unexpected large score $s2\n" ; $large_s = 1 ; }
	    
	    print INF "$t1 $s1 $t2 $s2\n" ;
	}			# 
    }
}
    print "total number of teams $T\n" ;
    print "total number of games $g\n" ;
for ( $t = 1 ; $t <= $T ; $t ++ ) {
    print "team $t : $teams[$t] \n";
    print TMS "$t $teams[$t] \n";
}
close (TMS); close (INF);
if ( $large_s ) { $arglist .= " -smax " . $smax . " " ; }
    $command = "infera -t $T -g $g -s $fileinf -tms $filetms -o $fileout $arglist $extra $extras\n" ; 
print $command ;
system $command ;		
open ( OUT , "< $fileout" ) ;
@a=<OUT>; @a =~ s/^\s*//g;
local(@keys);
foreach(@a){
    push(@keys, (split(' '))[$sort_on_me]) ;
}
sub bykeys { $keys[$b] <=> $keys[$a]; }
@sorta = @a[ sort bykeys $[..$#a];
print join("",@sorta) ;
# print join("\n",@keys) ;
open ( RAN , "> $fileran" ) ;
print RAN join("",@sorta) ;
print $command ;


